# Trade and Cultivation feature
# Trade and Cultivation feature
# From BoggyB
### Imports
from CvPythonExtensions import *
# import CvEventInterface
import CvUtil
import PAE_Unit
import PAE_Lists as L
### Defines
gc = CyGlobalContext()

### Globals
bInitialized = False # Whether global variables are already initialised
iMaxCitiesSpecialBonus = 3
iCitiesSpecialBonus = 0 # Cities with Special Trade Bonus

# Update (Ramk): CvUtil-Functions unpack an dict. You could directly use int, etc.

# Used keys for UnitScriptData:
# "x"/"y": coordinates of plots where bonus was picked up (merchants)
# "b": index of bonus stored in merchant/cultivation unit (only one at a time)
# "originCiv": original owner of the bonus stored in merchant (owner of the city where it was bought)

# For automated trade routes:
# "autX1"/"autX2"/"autY1"/"autY2": coordinates of cities in trade route
# "autB1": bonus bought in city 1/sold in city 2
# "autB2": bonus bought in city 2/sold in city 1
# "autA": if False, automated route is currently inactive
# "autLTC": latest turn when "doAutomateMerchant" was called for this unit. Sometimes it is called multiple times per turn, this prevents unnecessary calculations

# Used keys for CityScriptData:
# "b": free bonuses acquired via turns and until which turn they are available,
# e.g. {43:4, 23:8, 12:10} key: bonus index (int), value: num turns (int)

def init():
    global bInitialized
    global iCitiesSpecialBonus

    if not bInitialized:
        # Cities mit Special Trade Bonus herausfinden
        iRange = gc.getMAX_PLAYERS()
        for i in range(iRange):
            loopPlayer = gc.getPlayer(i)
            if loopPlayer.isAlive() and not loopPlayer.isBarbarian():
                (loopCity, pIter) = loopPlayer.firstCity(False)
                while loopCity:
                    if not loopCity.isNone() and loopCity.getOwner() == loopPlayer.getID(): #only valid cities
                        if CvUtil.getScriptData(loopCity, ["tsb"], -1) != -1:
                            iCitiesSpecialBonus += 1
                            if iCitiesSpecialBonus == iMaxCitiesSpecialBonus:
                                break
                    (loopCity, pIter) = loopPlayer.nextCity(pIter, False)
            if iCitiesSpecialBonus == iMaxCitiesSpecialBonus:
                break
        bInitialized = True

# --- Trade in cities ---

# Unit stores bonus, owner pays, if UnitOwner != CityOwner: city owner gets money
def doBuyBonus(pUnit, eBonus, iCityOwner):

    if not pUnit.getUnitType() in L.LTradeUnits:
        return

    if eBonus != -1:
        iBuyer = pUnit.getOwner()
        pBuyer = gc.getPlayer(iBuyer)

        eUnitBonus = CvUtil.getScriptData(pUnit, ["b"], -1)
        if eBonus == eUnitBonus:
            #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("Das haben wir bereits geladen.",)), None, 2, None, ColorTypes(10), 0, 0, False, False)
            return
        if eUnitBonus != -1:
            # Geladene Ressource automatisch verkaufen
            #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("Die Einheit hat bereits eine Ressource geladen.",)), None, 2, None, ColorTypes(10), 0, 0, False, False)
            if pUnit.plot().isCity():
              doSellBonus(pUnit, pUnit.plot().getPlotCity())
            else:
              CvUtil.removeScriptData(pUnit, "b")

        iPrice = int(_calculateBonusBuyingPrice(eBonus, iBuyer, iCityOwner))
        if pBuyer.getGold() < iPrice:
            CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_COLLECT_NO_GOODS", ("",)), None, 2, "Art/Interface/PlotPicker/Warning.dds", ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)
            return
        pBuyer.changeGold(-iPrice)

        iGewinnGold = iPrice

        pSeller = gc.getPlayer(iCityOwner)
        if iBuyer != iCityOwner:
            # 20%
            iGewinnGold = int(iPrice / 5) #* pSeller.getCurrentEra())
            pSeller.changeGold(iGewinnGold)
            

        CvUtil.addScriptData(pUnit, "b", eBonus)
        CvUtil.addScriptData(pUnit, "originCiv", iCityOwner)
        CvUtil.addScriptData(pUnit, "x", pUnit.getX())
        CvUtil.addScriptData(pUnit, "y", pUnit.getY())
        if pSeller.isHuman() and iBuyer != iCityOwner:
            sBonusName = gc.getBonusInfo(eBonus).getDescription()
            CyInterface().addMessage(iCityOwner, True, 10, CyTranslator().getText("TXT_KEY_BONUS_BOUGHT", (pBuyer.getName(), pBuyer.getCivilizationShortDescriptionKey(), pUnit.plot().getPlotCity().getName(), sBonusName, iGewinnGold)), "AS2D_COINS", 2, pUnit.getButton(), ColorTypes(8), pUnit.getX(), pUnit.getY(), True, True)

        if pBuyer.isHuman():
            CyInterface().addMessage(iBuyer, True, 5, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_COLLECT_GOODS", (gc.getBonusInfo(eBonus).getDescription(), -iPrice)), "AS2D_COINS", 2, None, ColorTypes(13), 0, 0, False, False)

        pUnit.finishMoves()
        if pUnit.isHuman(): PAE_Unit.doGoToNextUnit(pUnit)


def doSellBonus(pUnit, pCity):
    """Unit's store is emptied, unit owner gets money, city gets bonus, research push"""
    eBonus = CvUtil.getScriptData(pUnit, ["b"], -1)
    if eBonus != -1:
        iPrice = int(calculateBonusSellingPrice(pUnit, pCity))
        iBuyer = pCity.getOwner()
        pBuyer = gc.getPlayer(iBuyer)
        iSeller = pUnit.getOwner()
        pSeller = gc.getPlayer(iSeller)

        pSeller.changeGold(iPrice)

        # default: iSeller weil auch der Getreidekarren sein Gut abladen kann
        iOriginCiv = CvUtil.getScriptData(pUnit, ["originCiv"], iSeller) # where the goods come from
        #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "Trade: OriginCiv: " + str(iOriginCiv) + " | Buyer: " + str(iBuyer) + " | " + pSeller.getName() + " | " + gc.getBonusInfo(eBonus).getDescription(), None, 2, None, ColorTypes(8), 0, 0, False, False)

        # Forschungbonus
        iGewinnWissen = 0
        # Handelsstrasse
        # City Free Bonus
        # Bonus Spezialauftrag
        if iOriginCiv != iBuyer:
            iGewinnWissen = int(iPrice / 5 * pSeller.getCurrentEra())
            _doResearchPush(iBuyer, iGewinnWissen)
            _doCityProvideBonus(pCity, eBonus, 3)

            # Trade route / Handelsstrasse
            doBuildTradeRoute(pUnit, pCity)

            # Special Order Check
            if eBonus in L.LBonusLuxury + L.LBonusRarity:
                _doCheckCitySpecialBonus(pUnit, pCity, eBonus)

        sBonusName = gc.getBonusInfo(eBonus).getDescription()
        if pBuyer.isHuman() and iBuyer != iSeller:
            CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_BONUS_SOLD", (pSeller.getName(), pSeller.getCivilizationShortDescriptionKey(), pCity.getName(), sBonusName, iGewinnWissen)), None, 2, None, ColorTypes(8), pUnit.getX(), pUnit.getY(), False, False)
        elif pSeller.isHuman():
            CyInterface().addMessage(iSeller, True, 10, CyTranslator().getText("TXT_KEY_BONUS_SOLD2", (pCity.getName(), pBuyer.getCivilizationShortDescriptionKey(), sBonusName, iPrice, iGewinnWissen)), None, 2, None, ColorTypes(8), pUnit.getX(), pUnit.getY(), False, False)

        # Coin sound
        if iSeller == gc.getGame().getActivePlayer() or iBuyer == gc.getGame().getActivePlayer():
            CyAudioGame().Play2DSound("AS2D_COINS")

        CvUtil.removeScriptData(pUnit, "b")
        #pUnit.finishMoves()
        #PAE_Unit.doGoToNextUnit(pUnit)

# Handelsstrasse erstellen
def doBuildTradeRoute(pUnit, pCity):
    # Inits
    eBonus = CvUtil.getScriptData(pUnit, ["b"], -1)
    iBuyer = pCity.getOwner()
    pBuyer = gc.getPlayer(iBuyer)
    iSeller = pUnit.getOwner()
    pSeller = gc.getPlayer(iSeller)
    
    # Chance
    if pBuyer.hasBonus(eBonus): iChance = 10
    else: iChance = 20    
    # wenn die Stadt den Bonus bereits hat
    if CvUtil.hasBonusIgnoreFreeBonuses(pCity, eBonus): iChance -= 10
    # Better resources increase chance
    if eBonus in L.LBonusLuxury: iChance += 10
    elif eBonus in L.LBonusRarity: iChance += 20
    
    iRand = CvUtil.myRandom(100, "Handelsstrasse")
    #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "Trade Route: " + str(iRand) + " : " + str(iChance) + " | " + pSeller.getName(), None, 2, None, ColorTypes(8), 0, 0, False, False)
    #iChance = 100
    if iRand <= iChance:    
    
        pCity2 = None
        # Schiffe: Hafenstadt -> Hauptstadt
        if pUnit.getDomainType() == gc.getInfoTypeForString("DOMAIN_SEA"):            
            pSource = pCity.plot()
            pCity2 = pBuyer.getCapitalCity()
            pDest = pCity2.plot()
        # Landeinheiten: Stadt A -> B
        else:
            iOriginX = CvUtil.getScriptData(pUnit, ["x"], -1)
            iOriginY = CvUtil.getScriptData(pUnit, ["y"], -1)
            pSource = CyMap().plot(iOriginX, iOriginY)
            pDest = pCity.plot()
            
        if pSource is not None and not pSource.isNone():
            if pSource.isCity():
                iRouteType = gc.getInfoTypeForString("ROUTE_TRADE_ROAD")
                if pCity2 == None: pCity2 = pSource.getPlotCity()
                #CyInterface().addMessage(iSeller, True, 10, "Vor Traderoute", None, 2, None, ColorTypes(8), pUnit.getX(), pUnit.getY(), False, False)
                pPlotTradeRoad = getPlotTradingRoad(pSource, pDest)
                # Debug
                #if pPlotTradeRoad != None: 
                #    sz = "TRADEROAD x|y: " + str(pPlotTradeRoad.getX()) + "|" + str(pPlotTradeRoad.getY())
                #    CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, sz, None, 2, "Art/Terrain/Routes/handelsstrasse/button_handelsstrasse.dds", ColorTypes(10), pPlotTradeRoad.getX(), pPlotTradeRoad.getY(), True, True)
                #CyInterface().addMessage(iSeller, True, 10, "Nach Traderoute", None, 2, None, ColorTypes(8), pUnit.getX(), pUnit.getY(), False, False)
                if pPlotTradeRoad is not None:
                    pPlotTradeRoad.setRouteType(iRouteType)
                    if pBuyer.isHuman():
                        CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_TRADE_ROUTE_BUILT", (pSeller.getName(), pSeller.getCivilizationShortDescriptionKey(), pCity.getName(), pCity2.getName())), "AS2D_WELOVEKING", 2, "Art/Terrain/Routes/handelsstrasse/button_handelsstrasse.dds", ColorTypes(10), pPlotTradeRoad.getX(), pPlotTradeRoad.getY(), True, True)
                    if pSeller.isHuman() and iBuyer != iSeller:
                        CyInterface().addMessage(iSeller, True, 10, CyTranslator().getText("TXT_KEY_TRADE_ROUTE_BUILT2", (pCity.getName(), pCity2.getName())), "AS2D_WELOVEKING", 2, "Art/Terrain/Routes/handelsstrasse/button_handelsstrasse.dds", ColorTypes(10), pPlotTradeRoad.getX(), pPlotTradeRoad.getY(), True, True)
                    if iBuyer != iSeller and iSeller == gc.getGame().getActivePlayer() or iBuyer == gc.getGame().getActivePlayer():
                        CyAudioGame().Play2DSound("AS2D_WELOVEKING")
                        
                #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "Handelsroute erstellt", None, 2, "Art/Terrain/Routes/handelsstrasse/button_handelsstrasse.dds", ColorTypes(10), pPlotTradeRoad.getX(), pPlotTradeRoad.getY(), True, True)
                        
        # Sobald von einer Stadt 3 Handelsstrassen (bzw 2 bei einer Kuestenstadt) weggehen,
        # wird es zum Handelszentrum (Building: 100% auf Trade Routes)
        iBuilding = gc.getInfoTypeForString("BUILDING_HANDELSZENTRUM")
        if not pCity.isHasBuilding(iBuilding):
            iAnz = 0
            iMax = 3
            if pCity.isCoastal(4):
                iMax = 2
            for i in range(8):
                pLoopPlot = plotDirection(pCity.getX(), pCity.getY(), DirectionTypes(i))
                if pLoopPlot is not None and not pLoopPlot.isNone():
                    if pLoopPlot.getRouteType() == iRouteType:
                        iAnz += 1
                    if iAnz >= iMax:
                        break
            if iAnz >= iMax:
                pCity.setNumRealBuilding(iBuilding, 1)
                if pCity.getOwner() == gc.getGame().getActivePlayer():
                    CyInterface().addMessage(pCity.getOwner(), True, 10, CyTranslator().getText("TXT_KEY_TRADE_ROUTE_HANDELSZENTRUM", (pCity.getName(),)), "AS2D_WELOVEKING", 2, gc.getBuildingInfo(iBuilding).getButton(), ColorTypes(10), pCity.getX(), pCity.getY(), True, True)

# Gibt Plot zurueck, auf dem das naechste Handelsstrassen-Stueck entstehen soll bzw. ob die Strasse schon fertig ist. Von Pie.
def getPlotTradingRoad(pSource, pDest):
    # Nur auf gleichem Kontinent
    if pSource.getArea() == pDest.getArea():
        iSourceX = pSource.getX()
        iSourceY = pSource.getY()
        iDestX = pDest.getX()
        iDestY = pDest.getY()
        
        # Die nähesten 3 Plots zur Source-Stadt
        p = [None,None,None]
        # Ob diese Hills sind
        h = [0,0,0]

        # wenn pSource = pTarget (Haendler ueber Schiff im Hafen)
        if iSourceX != iDestX or iSourceY != iDestY:
            iTradeRoad = gc.getInfoTypeForString("ROUTE_TRADE_ROAD")
            bSourceGerade = False
            bTradeRoute = False
            # Herausfinden, ob bei pSource eine GERADE Strasse gebaut wurde
            # um zu verhindern, dass 2 Routen erstellt werden:
            #-------#
            #   --X #
            #  / /  #
            # X--   #
            #-------#
            # wenn es noch keine Strasse in der Stadt gibt => egal
            # wenn es eine Strasse gibt, dann den Umkreis checken
            if pSource.getRouteType() == iTradeRoad:
                iBest = 0
                for i in range(3):
                    for j in range(3):
                        loopPlot = gc.getMap().plot(iSourceX + i - 1, iSourceY + j - 1)
                        if not loopPlot.isNone():
                            if loopPlot.getRouteType() == iTradeRoad:
                                iTmp = gc.getMap().calculatePathDistance(loopPlot, pDest)
                                if iBest == 0:
                                    iBest = iTmp
                                
                                if iTmp == iBest and (i == 1 or j == 1):
                                    bSourceGerade = True
                                elif iTmp < iBest:
                                    bSourceGerade = (i == 1 or j == 1)

            # Wenn die Stadt noch keine Handelsstrasse hat
            if pDest.getRouteType() != iTradeRoad: return pDest
            
            # Den naechsten Plot fuer die Handelsstrasse herausfinden
            iBestX = iDestX
            iBestY = iDestY
            pBest = pDest
            while iBestX != iSourceX or iBestY != iSourceY:
                i = 0
                j = 0
                iBest = 0
                for i in range(3):
                    for j in range(3):
                        iX = iBestX + i - 1
                        iY = iBestY + j - 1
                        loopPlot = gc.getMap().plot(iX, iY)
                        if not loopPlot.isNone():
                            if not loopPlot.isPeak() and not loopPlot.isWater():
                                iTmp = gc.getMap().calculatePathDistance(loopPlot, pSource)
                                
                                # Debug
                                #sz = "S:" + str(iSourceX)+"|"+str(iSourceY) + " D:" + str(iDestX)+"|"+str(iDestY)
                                #sz += " x|y:" + str(iX) + "|" + str(iY)
                                #sz += " iTmp:" + str(iTmp) + " iBest:" + str(iBest) + " bSG:" + str(bSourceGerade) + " bTR:" + str(bTradeRoute)
                                #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, sz, None, 2, "", ColorTypes(10), 0, 0, 0, 0)
                                
                                # Beenden, wenn kein Weg moeglich
                                if iTmp == -1: return None
                                # wenn Distanz null ist, wurde der letzte Plot gefunden
                                elif iTmp == 0:
                                    if loopPlot.getRouteType() == iTradeRoad: return None
                                    return loopPlot
                                
                                if iBest == 0 or iTmp < iBest:
                                    iBest = iTmp
                                    pBest = loopPlot
                                    p = [loopPlot,None,None]
                                    if loopPlot.isHills(): h[0] = 1
                                elif iTmp == iBest:
                                    if p[1] == None: 
                                        p[1] = loopPlot
                                        if loopPlot.isHills(): h[1] = 1
                                    elif p[2] == None: 
                                        p[2] = loopPlot
                                        if loopPlot.isHills(): h[2] = 1
                
                # Die nähesten 3 Plots zur Richtung der Source Stadt                
                if p[0] != None and p[0].isCity(): pBest = p[0]
                elif p[1] != None and p[1].isCity(): pBest = p[1]
                elif p[2] != None and p[2].isCity(): pBest = p[2]                    
                else:
                    # Plots mit Hills ausnehmen
                    if not ((p[0] == None or h[0]) and (p[1] == None or h[1]) and (p[2] == None or h[2])) or not (not h[0] and not h[1] and not h[2]):
                        if h[0]: p[0] = None
                        if h[1]: p[1] = None
                        if h[2]: p[2] = None                    
                    
                    # Bei gleichen Entfernungen (max. 3 Moeglichkeiten: schraeg - gerade (- schraeg))
                    # Wenn bei der Quelle eine GERADE Strasse verlaeuft, dann schraeg bauen. Sonst umgekehrt.                                    
                    if p[1] != None and not bSourceGerade: pBest = p[1]
                    # wenn es nur mehr gerade zur Stadt geht (= ignoriert Hills)
                    #elif p[0] != None and (p[0].getX() == iSourceX or p[0].getY() == iSourceY): pBest = p[0]
                    #elif p[1] != None and (p[1].getX() == iSourceX or p[1].getY() == iSourceY): pBest = p[1]
                    #elif p[2] != None and (p[2].getX() == iSourceX or p[2].getY() == iSourceY): pBest = p[2]
                    else: 
                        if p[0] != None: pBest = p[0]
                        if p[1] != None and (abs(pBest.getX() - iSourceX) > abs(p[1].getX() - iSourceX) or abs(pBest.getY() - iSourceY) > abs(p[1].getY() - iSourceY)): pBest = p[1]
                        if p[2] != None and (abs(pBest.getX() - iSourceX) > abs(p[2].getX() - iSourceX) or abs(pBest.getY() - iSourceY) > abs(p[2].getY() - iSourceY)): pBest = p[2]
                        
                if pBest.getRouteType() != iTradeRoad: return pBest

                iBestX = pBest.getX()
                iBestY = pBest.getY()
    return None

# Player gets research points for current project (called when foreign goods are sold to player's cities)
def _doResearchPush(iPlayer1, iValue1):
    pPlayer1 = gc.getPlayer(iPlayer1)
#    pPlayer2 = gc.getPlayer(iPlayer2)
    pTeam1 = gc.getTeam(pPlayer1.getTeam())
#    pTeam2 = gc.getTeam(pPlayer2.getTeam())
    eTech1 = pPlayer1.getCurrentResearch()
#    eTech2 = pPlayer2.getCurrentResearch()
    if eTech1 != -1:
        pTeam1.changeResearchProgress(eTech1, iValue1, iPlayer1)
#    if eTech2 != -1: pTeam2.changeResearchProgress(eTech2, iValue2, iPlayer2)

# City can use bonus for x turns
def _doCityProvideBonus(pCity, eBonus, iTurn):
    # ScriptData value is dict, e.g. {43:4; 23:8; 12:10}
    # Key is 'iBonus' and value is 'iTurns'
    bonusDict = CvUtil.getScriptData(pCity, ["b"], {})
    
    # compatibility
    if isinstance(bonusDict, str):
        # Konvertiere altes Format "iB,iTurn;..." in dict
        tmp = [paar.split(",") for paar in str(bonusDict).split(";")]
        bonusDict = dict([map(int, pair) for pair in tmp])    
        
    if str(eBonus) not in bonusDict:        
        pCity.changeFreeBonus(eBonus, 1)
        
    # Addiere alten und neuen Rundenwert
    iCurrentTurn = gc.getGame().getGameTurn()
    
    #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "1 dict string: " + str(bonusDict), None, 2, None, ColorTypes(8), 0, 0, False, False)
    
    iTurn += iCurrentTurn
    dictNew = {str(eBonus):iTurn}
    bonusDict.update(dictNew)
    
    #bonusDict[eBonus] = iTurn + bonusDict.setdefault(eBonus, iCurrentTurn)
    #bonusDict[eBonus] = iTurn + iCurrentTurn
    CvUtil.addScriptData(pCity, "b", bonusDict)
    
    #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "2 dict string: " + str(bonusDict), None, 2, None, ColorTypes(8), 0, 0, False, False)


# Called each turn (onCityDoTurn, EventManager), makes sure free bonus disappears after x turns
def doCityCheckFreeBonuses(pCity):
    bonusDict = CvUtil.getScriptData(pCity, ["b"], {})
    bUpdate = False
    # compatibility
    if isinstance(bonusDict, str):
        # Konvertiere altes Format "iB,iTurn;..." in dict
        tmp = [paar.split(",") for paar in str(bonusDict).split(";")]
        bonusDict = dict([map(int, pair) for pair in tmp])
        bUpdate = True

    lRemove = []
    lAdd = {}
    for eBonus in bonusDict:
        iTurn = bonusDict[eBonus]

        # alte Saves korrigieren str->int
        if isinstance(eBonus, str):
            lRemove.append(eBonus)
            eBonus = int(eBonus)
            lAdd[eBonus] = iTurn

        if iTurn <= gc.getGame().getGameTurn():
            pCity.changeFreeBonus(eBonus, -1) # Time over: remove bonus from city
            lRemove.append(eBonus)
            bUpdate = True

    # alte Saves korrigieren str->int
    bonusDict.update(lAdd)

    for eBonus in lRemove:
        bonusDict.pop(eBonus, None)
    if bUpdate:
        CvUtil.addScriptData(pCity, "b", bonusDict)


# Creates popup with all the affordable bonuses for UnitOwner (bonuses too expensive for UnitOwner are cut)
def doPopupChooseBonus(pUnit, pCity):
    if pCity is None or pCity.isNone() or pUnit is None or pUnit.isNone():
        return False
    iBuyer = pUnit.getOwner()
    iSeller = pCity.getOwner()
    lGoods = getCitySaleableGoods(pCity, iBuyer)

    popupInfo = CyPopupInfo()
    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
    popupInfo.setText(CyTranslator().getText("TXT_KEY_POPUP_TRADE_CHOOSE_BONUS", ("", )))
    popupInfo.setOnClickedPythonCallback("popupTradeChooseBonus")
    popupInfo.setData1(pUnit.getOwner())
    popupInfo.setData2(pUnit.getID())

    for eBonus in lGoods:
        sBonusDesc = gc.getBonusInfo(eBonus).getDescription()
        iPrice = _calculateBonusBuyingPrice(eBonus, iBuyer, iSeller)
        iBonusOwned = gc.getPlayer(iBuyer).getNumAvailableBonuses(eBonus)
        sText = CyTranslator().getText("TXT_KEY_BUY_BONUS", (sBonusDesc, iPrice, iBonusOwned))
        sBonusButton = gc.getBonusInfo(eBonus).getButton()
        popupInfo.addPythonButton(sText, sBonusButton)

    popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_ACTION_CANCEL", ("", )), "Art/Interface/Buttons/Actions/Cancel.dds")
    popupInfo.setFlags(popupInfo.getNumPythonButtons()-1)
    popupInfo.addPopup(iBuyer)

# --- End of trade in cities

# --- Price stuff (trade) ---

# Basis value for each bonus
# auch in TXT_KEY_TRADE_ADVISOR_WERT_PANEL
def getBonusValue(eBonus):
    if eBonus == -1 or eBonus in L.LBonusUntradeable:
        return -1
    if eBonus in L.LBonusCorn + L.LBonusLivestock + L.LBonusPlantation:
        return 20
    elif eBonus in L.LBonusLuxury:
        return 40
    elif eBonus in L.LBonusRarity:
        return 50
    return 30 # strategic bonus ressource


# Price player pays for buying bonus
def _calculateBonusBuyingPrice(eBonus, iBuyer, iSeller):
    if iBuyer == -1 or iSeller == -1:
        return -1
    iValue = getBonusValue(eBonus)    
    if iBuyer == iSeller:
        iAttitudeModifier = 100
    else:
        # Furious = 0, Annoyed = 1, Cautious = 2, Pleased = 3, Friendly = 4
        iAttitudeModifier = 125 - 5 * gc.getPlayer(iSeller).AI_getAttitude(iBuyer)
    return (iValue * iAttitudeModifier) / 100


# Money player gets for selling bonus
def calculateBonusSellingPrice(pUnit, pCity):
    if not pUnit.getUnitType() in L.LTradeUnits:
      return -1
    eBonus = CvUtil.getScriptData(pUnit, ["b"], -1)
    if eBonus == -1: 
      return -1
    iX = CvUtil.getScriptData(pUnit, ["x"], -1)
    iY = CvUtil.getScriptData(pUnit, ["y"], -1)
    iSeller = CvUtil.getScriptData(pUnit, ["originCiv"], pUnit.getOwner())
    iBuyer = pCity.getOwner()
    iValue = getBonusValue(eBonus) # Grundwert
    iModifier = 0

    # Verkauf in der gleichen Stadt: Einkaufswert
    # Ware im gleichen Reich: Einkaufswert + 10%
    # Ware im anderen Reich: Grundwert + Attitude

    #if CvUtil.hasBonusIgnoreFreeBonuses(pCity, eBonus): # allows "cancellation" of buying / Bonus direkt nach Einkauf wieder verkaufen (ohne Gewinn)
    #    return _calculateBonusBuyingPrice(eBonus, iSeller, iBuyer) # Switch positions of seller and buyer

    if pUnit.getX() == iX and pUnit.getY() == iY:
      return _calculateBonusBuyingPrice(eBonus, iSeller, iBuyer) # Switch positions of seller and buyer
    elif iBuyer == iSeller:
      iValue = _calculateBonusBuyingPrice(eBonus, iSeller, iBuyer)
    else:
      # Furious = 0, Annoyed = 1, Cautious = 2, Pleased = 3, Friendly = 4
      iModifier = 10 * gc.getPlayer(iSeller).AI_getAttitude(iBuyer)

    # Hauptstadt +10% 
    if pCity.isCapital(): iModifier += 10
    
    # Stadt hat dieses Bonusgut nicht im Handelsnetz
    if not pCity.hasBonus(eBonus): iModifier += 20

    #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("iValue",iValue)), None, 2, None, ColorTypes(10), 0, 0, False, False)
    #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("iModifier",iModifier)), None, 2, None, ColorTypes(10), 0, 0, False, False)
    #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("City Pop.",pCity.getPopulation())), None, 2, None, ColorTypes(10), 0, 0, False, False)
    #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("100 + Pop * 5",(100 + pCity.getPopulation() * 5))), None, 2, None, ColorTypes(10), 0, 0, False, False)
    #CyInterface().addMessage(iBuyer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TEST",("Gesamt",(iValue * iModifier * (100 + pCity.getPopulation() * 5)) / 10000)), None, 2, None, ColorTypes(10), 0, 0, False, False)
    return int((iValue * (100 + iModifier + pCity.getPopulation() * 5)) / 100)
# --- End of price stuff (trade) ---


# --- Automated trade routes (popups for HI) ---

# Erzeugt Popup fuer Erstellung einer automatisierten Handelsroute, wird insgesamt sechsmal pro Route aufgerufen:
# Civ waehlen => Stadt waehlen => Bonus waehlen => Civ waehlen => Stadt waehlen => Bonus waehlen
# iType = 1, 2, ...., 6 gibt an, an welcher Stelle im Prozess man gerade ist (1: erste Civ waehlen, ..., 6: zweiten Bonus waehlen)
# iData1/2: Ggf. noetige, zusaetzliche Informationen
def doPopupAutomatedTradeRoute(pUnit, iType, iData1, iData2):
    iUnitOwner = pUnit.getOwner()

    # Popup Info: Funktion wird nur (indirekt) 
    #             durch ModNetMessages erreicht. Achtung,
    #             OOS-Aktionen alle vor diesem if-statement ausführen.
    if gc.isPitbossHost() or iUnitOwner != gc.getGame().getActivePlayer():
        return

    if iType == 1 or iType == 4:
        # Choose civilization 1 (iType == 1) or civilization 2 (iType == 4)
        popupInfo = CyPopupInfo()
        popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
        if iType == 1:
            popupInfo.setText(CyTranslator().getText("TXT_KEY_POPUP_TRADE_ROUTE_CHOOSE_CIV_1", ("", )))
        else:
            popupInfo.setText(CyTranslator().getText("TXT_KEY_POPUP_TRADE_ROUTE_CHOOSE_CIV_2", ("", )))
        popupInfo.setOnClickedPythonCallback("popupTradeRouteChooseCiv")
        popupInfo.setData1(iUnitOwner)
        popupInfo.setData2(pUnit.getID())
        popupInfo.setData3(iType == 1)
        lCivs = getPossibleTradeCivs(iUnitOwner)
        for iPlayer in lCivs:
            pPlayer = gc.getPlayer(iPlayer)
            sText = pPlayer.getCivilizationShortDescription(0) + " (" + pPlayer.getName() + ")"
            sButton = gc.getCivilizationInfo(pPlayer.getCivilizationType()).getButton()
            popupInfo.addPythonButton(sText, sButton)

        popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_ACTION_CANCEL", ("", )), "Art/Interface/Buttons/Actions/Cancel.dds")
        popupInfo.setFlags(popupInfo.getNumPythonButtons()-1)
        popupInfo.addPopup(iUnitOwner)
    elif iType == 2 or iType == 5:
        # Choose city 1 (iType == 2) or city 2 (iType == 5)
        iCityOwner = iData1
        popupInfo = CyPopupInfo()
        popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
        popupInfo.setText(CyTranslator().getText("TXT_KEY_POPUP_TRADE_ROUTE_CHOOSE_CITY", ("", )))
        if iType == 2:
            popupInfo.setOnClickedPythonCallback("popupTradeRouteChooseCity1")
        else:
            popupInfo.setOnClickedPythonCallback("popupTradeRouteChooseCity2")
        popupInfo.setData1(iUnitOwner)
        popupInfo.setData2(pUnit.getID())
        popupInfo.setData3(iCityOwner)
        bWater = False
        if pUnit.getDomainType() == DomainTypes.DOMAIN_SEA:
            bWater = True
        lCities = getPossibleTradeCitiesForCiv(iUnitOwner, iCityOwner, bWater)
        sButton = ",Art/Interface/Buttons/Actions/FoundCity.dds,Art/Interface/Buttons/Actions_Builds_LeaderHeads_Specialists_Atlas.dds,1,4"
        for pCity in lCities:
            sText = pCity.getName()
            if pCity.isCapital(): sText += CyTranslator().getText(" [ICON_STAR]", ())
            popupInfo.addPythonButton(sText, sButton)
        popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_ACTION_CANCEL", ("", )), "Art/Interface/Buttons/Actions/Cancel.dds")
        popupInfo.setFlags(popupInfo.getNumPythonButtons()-1)
        popupInfo.addPopup(iUnitOwner)
    elif iType == 3 or iType == 6:
        # Choose bonus to buy in selected city.
        pCity = gc.getPlayer(iData1).getCity(iData2)
        sCityName = pCity.getName()
        lGoods = getCitySaleableGoods(pCity, -1)
        lGoods.append(-1)
        popupInfo = CyPopupInfo()
        popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
        popupInfo.setText(CyTranslator().getText("TXT_KEY_POPUP_TRADE_ROUTE_CHOOSE_BONUS", (sCityName, )))
        popupInfo.setOnClickedPythonCallback("popupTradeRouteChooseBonus")
        popupInfo.setData1(iUnitOwner)
        popupInfo.setData2(pUnit.getID())
        popupInfo.setData3(iType == 3)
        for eBonus in lGoods:
            if eBonus != -1:
                sText = gc.getBonusInfo(eBonus).getDescription()
                sButton = gc.getBonusInfo(eBonus).getButton()
                popupInfo.addPythonButton(sText, sButton)
            else:
                sText = CyTranslator().getText("TXT_KEY_NO_BONUS", ("", ))
                sButton = "Art/Interface/Buttons/Techs/button_x.dds"
                popupInfo.addPythonButton(sText, sButton)
        popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_ACTION_CANCEL", ("", )), "Art/Interface/Buttons/Actions/Cancel.dds")
        popupInfo.setFlags(popupInfo.getNumPythonButtons()-1)
        popupInfo.addPopup(iUnitOwner)
# --- End of automated trade routes for HI ---

# --- Helper functions ---
def getCitySaleableGoods(pCity, iBuyer):        
    """ Returns a list of the tradeable bonuses within pCity's range (radius of 2) + bonuses from buildings (bronze etc.). Only goods within the team's culture are considered.
        if iBuyer != -1: Bonuses the buying player cannot afford (not enough money) are excluded
    """
    if pCity is None or pCity.isNone(): return []
    iCityOwnerTeam = pCity.getTeam()
    iCityOwner = pCity.getOwner()
    # pCityOwner = gc.getPlayer(iCityOwner)
    if iBuyer != -1: iMaxPrice = gc.getPlayer(iBuyer).getGold()
    
    lGoods = []
    iX = pCity.getX()
    iY = pCity.getY()
    for x in range(5): # check plots
        for y in range(5):
            pLoopPlot = gc.getMap().plot(iX + x - 2, iY + y - 2)
            if pLoopPlot is not None and not pLoopPlot.isNone():
                if pLoopPlot.getTeam() != iCityOwnerTeam:
                    continue
                # plot needs to have suitable improvement and city needs to have access to bonus (=> connection via trade route (road))
                eBonus = pLoopPlot.getBonusType(iCityOwnerTeam)
                eImprovement = pLoopPlot.getImprovementType()
                if eBonus != -1 and eBonus not in lGoods and eBonus not in L.LBonusUntradeable:
                    #if CvUtil.hasBonusIgnoreFreeBonuses(pCity, eBonus):
                    if pLoopPlot.isCity() or eImprovement != -1 and gc.getImprovementInfo(eImprovement).isImprovementBonusMakesValid(eBonus):
                            if iBuyer == -1 or _calculateBonusBuyingPrice(eBonus, iBuyer, iCityOwner) <= iMaxPrice: # Max price
                                lGoods.append(eBonus)
    
    iMaxNumBuildings = gc.getNumBuildingInfos()
    for iBuilding in range(iMaxNumBuildings): # check buildings
        if pCity.isHasBuilding(iBuilding):
            eBonus = gc.getBuildingInfo(iBuilding).getFreeBonus()
            if eBonus != -1 and eBonus not in L.LBonusUntradeable and eBonus not in lGoods: # and CvUtil.hasBonusIgnoreFreeBonuses(pCity, eBonus):
                if iBuyer == -1 or _calculateBonusBuyingPrice(eBonus, iBuyer, iCityOwner) <= iMaxPrice: # Max price
                    lGoods.append(eBonus)
    return lGoods

# Returns list of civs iPlayer can trade with (has met and peace with). List always includes iPlayer himself.
def getPossibleTradeCivs(iPlayer):
    pTeam = gc.getTeam(gc.getPlayer(iPlayer).getTeam())
    lCivList = []
    for iCiv in range(gc.getMAX_PLAYERS()):
        iCivTeam = gc.getPlayer(iCiv).getTeam()
        if pTeam.isHasMet(iCivTeam) and not pTeam.isAtWar(iCivTeam):
            lCivList.append(iCiv)
    return lCivList

# Returns list of cities which 1. belong to iPlayer2 and 2. are visible to iPlayer1
def getPossibleTradeCitiesForCiv(iPlayer1, iPlayer2, bWater):
    iTeam1 = gc.getPlayer(iPlayer1).getTeam()
    pPlayer2 = gc.getPlayer(iPlayer2)
    lCityList = []
    (loopCity, pIter) = pPlayer2.firstCity(False)
    while loopCity:
        if not loopCity.isNone() and loopCity.getOwner() == iPlayer2: #only valid cities
            if loopCity.isRevealed(iTeam1, 0):
                if not bWater or loopCity.isCoastal(4):
                    lCityList.append(loopCity)
        (loopCity, pIter) = pPlayer2.nextCity(pIter, False)
    return lCityList


# --- AI and automated trade routes ---

# Lets pUnit shuttle between two cities (defined by UnitScriptData). Used by AI and by HI (automated trade routes).
def doAutomateMerchant(pUnit):
    # DEBUG
    #iHumanPlayer = gc.getGame().getActivePlayer()
    #if pUnit.getOwner() == iHumanPlayer:
    #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit is active", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)  
    bTradeRouteActive = int(CvUtil.getScriptData(pUnit, ["autA", "t"], 0))
    if bTradeRouteActive: # and pUnit.getGroup().getLengthMissionQueue() == 0:        
                
        iPlayer = pUnit.getOwner()
        pUnitPlot = pUnit.plot()
        iTurn = gc.getGame().getGameTurn()
        #pUnit.getGroup().clearMissionQueue()   

        #if iPlayer == iHumanPlayer:
        #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit autLTC: " + str(CvUtil.getScriptData(pUnit, ["autLTC"], -1)), None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)         
                
        # Verhindern, dass mehrmals pro Runden geprueft wird, um Rundenzeit zu sparen
        # Z.B. bei bedrohten Einheiten ruft Civ die Funktion sonst 100 Mal auf, weiss nicht wieso...
        iLastTurnChecked = CvUtil.getScriptData(pUnit, ["autLTC"], -1)
        if iLastTurnChecked >= iTurn and not pUnit.isHuman():
            return False
        else:
          CvUtil.addScriptData(pUnit, "autLTC", iTurn)
        
        eStoredBonus = CvUtil.getScriptData(pUnit, ["b"], -1)
        iX1 = CvUtil.getScriptData(pUnit, ["autX1"], -1)
        iY1 = CvUtil.getScriptData(pUnit, ["autY1"], -1)
        iX2 = CvUtil.getScriptData(pUnit, ["autX2"], -1)
        iY2 = CvUtil.getScriptData(pUnit, ["autY2"], -1)
        eBonus1 = CvUtil.getScriptData(pUnit, ["autB1"], -1) # bonus bought in city 1
        eBonus2 = CvUtil.getScriptData(pUnit, ["autB2"], -1) # bonus bought in city 2
        pCityPlot1 = CyMap().plot(iX1, iY1)
        pCityPlot2 = CyMap().plot(iX2, iY2)
        pCity1 = pCityPlot1.getPlotCity()
        pCity2 = pCityPlot2.getPlotCity()
        
        #if iPlayer == iHumanPlayer:
        #txt = u"Player: %d | Bonus: %d, (x1:%d|y1:%d|b:%d) -> (x2:%d|y2:%d|b:%d) autLTC:%d" % (iPlayer,eStoredBonus,iX1,iY1,eBonus1,iX2,iY2,eBonus2,iLastTurnChecked)
        #CyInterface().addMessage(iHumanPlayer, True, 10, txt, None, 2, pUnit.getButton(), ColorTypes(10), pUnit.getX(), pUnit.getY(), True, True)
        
        if pCity1 is None or pCity1.isNone() or pCity2 is None or pCity2.isNone():
            # delete invalid trade route
            CvUtil.removeScriptData(pUnit, "autA")
            CvUtil.removeScriptData(pUnit, "autLTC")
            CvUtil.removeScriptData(pUnit, "autX1")
            CvUtil.removeScriptData(pUnit, "autY1")
            CvUtil.removeScriptData(pUnit, "autX2")
            CvUtil.removeScriptData(pUnit, "autY2")
            CvUtil.removeScriptData(pUnit, "autB1")
            CvUtil.removeScriptData(pUnit, "autB2")
            return False
        
        if pUnit.atPlot(pCityPlot1) or pUnit.atPlot(pCityPlot2):
            if pUnit.atPlot(pCityPlot1):
                pCurrentCity = pCity1
                pNewCity = pCity2
                eBonusBuy = eBonus1
                eBonusSell = eBonus2
            elif pUnit.atPlot(pCityPlot2):
                pCurrentCity = pCity2
                pNewCity = pCity1
                eBonusBuy = eBonus2
                eBonusSell = eBonus1
                
            #if eBonusSell != -1 and eStoredBonus == eBonusSell:
            if eStoredBonus != -1 and eStoredBonus != eBonusBuy: 
                doSellBonus(pUnit, pCurrentCity)
                #if iPlayer == iHumanPlayer:
                #CyInterface().addMessage(iHumanPlayer, True, 10, "Unit sold bonus in city", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True) 
            
            #if iPlayer == iHumanPlayer:
            #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit is in City", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)            
            
            # HI: if player does not have enough money, trade route is cancelled
            # AI: if AI does not have enough money, AI buys bonus nonetheless (causes no known errors)
            ## doBuyBonus doesn't work this way. AIs traderoute will be deactivated as well. 
            if pUnit.isHuman(): iBuyer = iPlayer
            else: iBuyer = -1
            lCitySaleableGoods = getCitySaleableGoods(pCurrentCity, iBuyer)
            
            if eBonusBuy == -1:
                #CyInterface().addMessage(iHumanPlayer, True, 10, "Mission eBonusBuy == -1 ", None, 2, None, ColorTypes(7), 0, 0, False, False)
                #pUnit.getGroup().pushMoveToMission(pNewCity.getX(), pNewCity.getY())
                pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, pNewCity.getX(), pNewCity.getY(), 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
            elif eStoredBonus == eBonusBuy:
                #CyInterface().addMessage(iHumanPlayer, True, 10, "Mission eBonusBuy == eStoredBonus | got to " + pNewCity.getName(), None, 2, None, ColorTypes(7), 0, 0, False, False)
                #pUnit.getGroup().pushMoveToMission(pNewCity.getX(), pNewCity.getY())
                pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, pNewCity.getX(), pNewCity.getY(), 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
            elif eBonusBuy in lCitySaleableGoods:
                #if iPlayer == iHumanPlayer: CyInterface().addMessage(iHumanPlayer, True, 10, "Mission eBonusBuy in lCitySaleable ", None, 2, None, ColorTypes(7), 0, 0, False, False)
                if eStoredBonus != eBonusBuy:
                    # if not already acquired / Wenn Bonus nicht bereits gekauft wurde
                    #if not pUnit.hasMoved():
                    doBuyBonus(pUnit, eBonusBuy, pCurrentCity.getOwner())
                    #CyInterface().addMessage(iHumanPlayer, True, 10, "Mission eStoredBonus != eBonusBuy SKIP", None, 2, None, ColorTypes(7), 0, 0, False, False)
                    #pUnit.getGroup().pushMission(MissionTypes.MISSION_SKIP, 0, 0, 0, True, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
                    pUnit.finishMoves()
                    return True
                #CyInterface().addMessage(iHumanPlayer, True, 10, "Mission eBonusBuy MOVE to new city ", None, 2, None, ColorTypes(7), 0, 0, False, False)
                #pUnit.getGroup().pushMoveToMission(pNewCity.getX(), pNewCity.getY())
                pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, pNewCity.getX(), pNewCity.getY(), 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
                return True
                
            else:
                # bonus is no longer available (or player does not have enough money) => cancel automated trade route
                CvUtil.addScriptData(pUnit, "autA", 0) # deactivate route
                #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant False: Bonus no longer available", None, 2, None, ColorTypes(7), 0, 0, False, False)
                return False
        else:
            # unit is anywhere
            #if iPlayer == 12:
            #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit is anywhere", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)  
            if eStoredBonus == eBonus1:
                #pUnit.getGroup().pushMoveToMission(pCityPlot2.getX(), pCityPlot2.getY())
                pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, iX2, iY2, 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
                #if iPlayer == 12:
                #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit is anywhere: eStoredBonus == eBonus1", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)
            elif eStoredBonus == eBonus2:
                #pUnit.getGroup().pushMoveToMission(pCityPlot1.getX(), pCityPlot1.getY())
                # VOID pushMission (MissionType eMission, INT iData1, INT iData2, INT iFlags, BOOL bAppend, BOOL bManual, MissionAIType eMissionAI, CyPlot pMissionAIPlot, CyUnit pMissionAIUnit)
                # iFlags = 1: MOVE_THROUGH_ENEMY
                pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, iX1, iY1, 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
                #if iPlayer == 12:
                #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit is anywhere: eStoredBonus == eBonus2", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)
            else:
                # auch wenn eBonus = -1
                #if iPlayer == 12:
                #  CyInterface().addMessage(iHumanPlayer, True, 10, "Unit is anywhere: else", None, 2, None, ColorTypes(7), pUnit.getX(), pUnit.getY(), True, True)            
                iDistance1 = CyMap().calculatePathDistance(pUnitPlot, pCityPlot1)
                iDistance2 = CyMap().calculatePathDistance(pUnitPlot, pCityPlot2)
                if iDistance1 == -1 and iDistance2 == -1:
                    #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant False: Plot unreachable", None, 2, None, ColorTypes(7), 0, 0, False, False)
                    return False # plot unreachable
                elif iDistance1 == -1:
                    #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant iDistance1 == -1 ", None, 2, None, ColorTypes(6), 0, 0, False, False)
                    #pUnit.getGroup().pushMoveToMission(pCityPlot2.getX(), pCityPlot2.getY())
                    pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, iX2, iY2, 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
                elif iDistance2 == -1 or iDistance1 <= iDistance2:
                    #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant iDistance1 smaller than iDistance2 ", None, 2, None, ColorTypes(6), 0, 0, False, False)
                    #pUnit.getGroup().pushMoveToMission(pCityPlot1.getX(), pCityPlot1.getY())
                    pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, iX1, iY1, 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
                else:
                    #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant else ", None, 2, None, ColorTypes(6), 0, 0, False, False)
                    #pUnit.getGroup().pushMoveToMission(pCityPlot2.getX(), pCityPlot2.getY())
                    pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, iX2, iY2, 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)

        #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant returns True ", None, 2, None, ColorTypes(6), 0, 0, False, False)
        return True

    #CyInterface().addMessage(iHumanPlayer, True, 10, "doAutomateMerchant returns False " + str(pUnit.getOwner()), None, 2, None, ColorTypes(7), 0, 0, False, False)
    return False

# Weist der Einheit eine moeglichst kurze Handelsroute zu, die moeglichst so verlaeuft, dass an beiden Stationen ein Luxusgut eingeladen wird
def doAssignTradeRoute_AI(pUnit):
    # iHumanPlayer = -1 (Needed for test messages, otherwise unnecessary)
    iPlayer = pUnit.getOwner()
    pPlayer = gc.getPlayer(iPlayer)
    pTeam = gc.getTeam(pPlayer.getTeam())
    pUnitPlot = pUnit.plot()

    if pPlayer.getGold() < 50:
        return False

    bTradeRouteActive = int(CvUtil.getScriptData(pUnit, ["autA", "t"], 0))
    if bTradeRouteActive: 
        return False
        
    # friedliche Nachbarn raussuchen
    lNeighbors = []
    iRange = gc.getMAX_PLAYERS()
    for iLoopPlayer in range(iRange):
        pLoopPlayer = gc.getPlayer(iLoopPlayer)
        if pLoopPlayer.isAlive() and iLoopPlayer != iPlayer:
            if pTeam.isHasMet(pLoopPlayer.getTeam()):
                if pTeam.isOpenBorders(pLoopPlayer.getTeam()):
                    # widerspricht ohnehin open borders
                    # if not pTeam.isAtWar(pLoopPlayer.getTeam()):
                    # Distanz mittels Abstand zur Hauptstadt herausfinden
                    (loopCity, pIter) = pLoopPlayer.firstCity(False)
                    while loopCity:
                        if not loopCity.isNone() and loopCity.getOwner() == iLoopPlayer: #only valid cities
                            if loopCity.isCapital():
                                iDistance = CyMap().calculatePathDistance(pUnitPlot, loopCity.plot())
                                if iDistance != -1:
                                    lNeighbors.append([iDistance, iLoopPlayer])
                        (loopCity, pIter) = pLoopPlayer.nextCity(pIter, False)
                    # if not pLoopPlayer.getCity(0).isNone():
                        # iDistance = CyMap().calculatePathDistance(pUnitPlot, pLoopPlayer.getCity(0).plot())
                        # if iDistance != -1:
                            # lNeighbors.append([iDistance, iLoopPlayer])

    lNeighbors.sort() # sort by distance
    lNeighbors = lNeighbors[:5] # only check max. 5 neighbors
    # Liste aller Staedte des Spielers mit verfuegbaren Luxusguetern. Staedte ohne Luxusgut ausgelassen.
    lPlayerLuxuryCities = _getPlayerLuxuryCities(iPlayer)
    iMaxDistance = 15 # Wie weit die KI einen Haendler max. schickt
    iMinDistance = -1
    bBothDirections = False
    pBestPlayerCity = None
    pBestNeighborCity = None
    for [iDistance, iNeighbor] in lNeighbors:
        lNeighborLuxuryCities = _getPlayerLuxuryCities(iNeighbor)
        # Sucht nach Paar von Staedten, zwischen denen Luxushandel moeglich ist, mit min. Distanz.
        # Routen, bei denen in beiden Staedten Luxus eingekauft werden kann, der in der anderen Stadt wieder verkauft
        # werden kann (=> Bonus NICHT in beiden Staedten), werden bevorzugt (dann ist bBothDirections = True).
        # Sonst wird eine Route gewaehlt, bei der der Haendler nur in eine Richtung handelt (andere Richtung Leertransport)
        for [pNeighborCity, lNeighborCityLuxury] in lNeighborLuxuryCities:
            for [pPlayerCity, lPlayerCityLuxury] in lPlayerLuxuryCities:
                pCityPlotPlayer = pPlayerCity.plot()
                pCityPlotNeighbor = pNeighborCity.plot()
                # Handelsstrasse existiert schon => andere Route waehlen
                if getPlotTradingRoad(pCityPlotPlayer, pCityPlotNeighbor) is None:
                    continue
                    
                iDistance = CyMap().calculatePathDistance(pCityPlotPlayer, pCityPlotNeighbor)
                if iDistance == -1 or iDistance > iMaxDistance:
                    continue
                    
                #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "Keine Handelsstrasse", None, 2, None, ColorTypes(8), pUnit.getX(), pUnit.getY(), False, False)
                bDirection1 = False
                bDirection2 = False
                for eBonus in lNeighborCityLuxury:
                    if not pPlayerCity.hasBonus(eBonus):
                        bDirection1 = True
                        break
                for eBonus in lPlayerCityLuxury:
                    if not pNeighborCity.hasBonus(eBonus):
                        bDirection2 = True
                        break
                
                #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "iDistance != -1", None, 2, None, ColorTypes(8), pUnit.getX(), pUnit.getY(), False, False)
                if bDirection1 and bDirection2:
                        if iMinDistance == -1 or iDistance < iMinDistance or not bBothDirections:
                            bBothDirections = True
                            iMinDistance = iDistance
                            pBestPlayerCity = pPlayerCity
                            pBestNeighborCity = pNeighborCity
                            # Wenn Route, die in beide Richtungen funktioniert, gefunden wurde, abbrechen (spart Rechenzeit)
                            # Route ist zwar ggf. nicht optimal, aber gut genug (beide Richtungen, Abstand <= iMaxDistance)
                            break
                elif (bDirection1 or bDirection2) and not bBothDirections:
                        if iMinDistance == -1 or iDistance < iMinDistance:
                            iMinDistance = iDistance
                            pBestPlayerCity = pPlayerCity
                            pBestNeighborCity = pNeighborCity
            # Wenn Route, die in beide Richtungen funktioniert, gefunden wurde, abbrechen (spart Rechenzeit)
            # Route ist zwar ggf. nicht optimal, aber gut genug (beide Richtungen, Abstand <= iMaxDistance)
            if bBothDirections:
                break
        if bBothDirections:
            break
    
    # Wenn KI keine Stadt findet, weil sie schon alles hat, dann auf zur groessten Stadt
    if pBestPlayerCity is None: 
        pBestPlayerCity = _getBestCity4Trade(pUnit,iPlayer)
    if pBestNeighborCity is None: 
        for [iDistance, iNeighbor] in lNeighbors:
            pBestNeighborCity = _getBestCity4Trade(pUnit,iNeighbor)
            break

    if pBestPlayerCity is not None and pBestNeighborCity is not None:
        #CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, "Stadt gefunden " + pBestPlayerCity.getName()+" nach "+pBestNeighborCity.getName(), None, 2, None, ColorTypes(10), 0, 0, False, False)
        lPlayerLuxuries = _getCityLuxuries(pBestPlayerCity)
        lNeighborLuxuries = _getCityLuxuries(pBestNeighborCity)
        lBonus1 = []
        lBonus2 = []
        for eBonus in lPlayerLuxuries:
            if not pBestNeighborCity.hasBonus(eBonus):
                lBonus1.append(eBonus)                
        for eBonus in lNeighborLuxuries:
            if not pBestPlayerCity.hasBonus(eBonus):
                lBonus2.append(eBonus)                
                
        if not lBonus1: lBonus1 = getCitySaleableGoods(pBestPlayerCity, -1)            
        eBonus1 = lBonus1[CvUtil.myRandom(len(lBonus1), "get any bonus 4 trade")]
        if not lBonus2: lBonus2 = getCitySaleableGoods(pBestNeighborCity, -1)
        eBonus2 = lBonus2[CvUtil.myRandom(len(lBonus2), "get any bonus 4 trade")]               
        
        CvUtil.addScriptData(pUnit, "autX1", pBestPlayerCity.getX())
        CvUtil.addScriptData(pUnit, "autY1", pBestPlayerCity.getY())
        CvUtil.addScriptData(pUnit, "autX2", pBestNeighborCity.getX())
        CvUtil.addScriptData(pUnit, "autY2", pBestNeighborCity.getY())
        CvUtil.addScriptData(pUnit, "autB1", eBonus1) # bonus bought in city 1
        CvUtil.addScriptData(pUnit, "autB2", eBonus2) # bonus bought in city 2
        CvUtil.addScriptData(pUnit, "autA", 1)
        
        #pUnit.getGroup().pushMoveToMission(pBestPlayerCity.getX(), pBestPlayerCity.getY())
        pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, pBestPlayerCity.getX(), pBestPlayerCity.getY(), 1, False, False, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
        return True

    return False

# Returns list of iPlayer's cities and the luxuries in their reach (saleable). Cities without luxuries are skipped.
# e.g. returns [ [pCity1, [3, 34, 7]], [pCity2, [3, 7, 13] ]
def _getPlayerLuxuryCities(iPlayer):
    pPlayer = gc.getPlayer(iPlayer)
    lCityList = []
    (loopCity, pIter) = pPlayer.firstCity(False)
    while loopCity:
        if not loopCity.isNone() and loopCity.getOwner() == pPlayer.getID(): #only valid cities
            lLuxuryGoods = _getCityLuxuries(loopCity)
            if lLuxuryGoods:
                lCityList.append([loopCity, lLuxuryGoods])
        (loopCity, pIter) = pPlayer.nextCity(pIter, False)
    return lCityList

# Returns list of the luxuries in reach of pCity (saleable). Used by AI trade route determination.
def _getCityLuxuries(pCity):
    lBonuses = getCitySaleableGoods(pCity, -1)
    lBonuses2 = CvUtil.getIntersection(L.LBonusStrategic, lBonuses)
    lBonuses2 += CvUtil.getIntersection(L.LBonusRarity, lBonuses)
    lBonuses2 += CvUtil.getIntersection(L.LBonusLuxury, lBonuses)
    if lBonuses2: return lBonuses2    
    lBonuses2 = CvUtil.getIntersection(L.LBonusPlantation, lBonuses)
    if lBonuses2: return lBonuses2
    return lBonuses
    
# Returns the iPlayer's biggest city depending on distance of pUnit
def _getBestCity4Trade(pUnit, iPlayer):
    pPlayer = gc.getPlayer(iPlayer)
    pUnitPlot = pUnit.plot()
    
    iDistance = 99
    iPop = 0
    pCity = None    
    (loopCity, pIter) = pPlayer.firstCity(False)
    while loopCity:
        if not loopCity.isNone():            
            lBonuses = getCitySaleableGoods(loopCity, -1)
            if len(lBonuses) > 0:            
                iLoopCityDistance = CyMap().calculatePathDistance(pUnitPlot, loopCity.plot())
                iLoopCityPop = loopCity.getPopulation()
                if iLoopCityPop > iPop or iLoopCityPop == iPop and iLoopCityDistance < iDistance:
                    iDistance = iLoopCityDistance
                    iPop = iLoopCityPop
                    pCity = loopCity             
        (loopCity, pIter) = pPlayer.nextCity(pIter, False)
    return pCity    

############# Cities with special bonus order #################
# tsb: TradeSpecialBonus
# tst: TradeSpecialTurns
def doUpdateCitiesWithSpecialBonus(iGameTurn):
    global iCitiesSpecialBonus
    # Cities mit Special Trade Bonus herausfinden
    for i in range(gc.getMAX_PLAYERS()):
        loopPlayer = gc.getPlayer(i)
        if loopPlayer.isAlive() and not loopPlayer.isBarbarian():
            (loopCity, pIter) = loopPlayer.firstCity(False)
            while loopCity:
                if not loopCity.isNone() and loopCity.getOwner() == loopPlayer.getID(): #only valid cities
                    iTurn = CvUtil.getScriptData(loopCity, ["tst"], -1)
                    if iTurn != -1 and iTurn <= iGameTurn:
                        eBonus = CvUtil.getScriptData(loopCity, ["tsb"], -1)
                        CvUtil.removeScriptData(loopCity, "tsb")
                        CvUtil.removeScriptData(loopCity, "tst")
                        iCitiesSpecialBonus -= 1
                        if eBonus != -1:
                            iCityOwner = loopCity.getOwner()
                            pPlayer = gc.getPlayer(iCityOwner)
                            pTeam = gc.getTeam(pPlayer.getTeam())
                            iActivePlayer = gc.getGame().getActivePlayer()
                            if pTeam.isHasMet(gc.getPlayer(iActivePlayer).getTeam()):
                                CyInterface().addMessage(iActivePlayer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_SPECIAL_1", (loopCity.getName(), gc.getBonusInfo(eBonus).getDescription())), None, 2, None, ColorTypes(13), 0, 0, False, False)
                (loopCity, pIter) = loopPlayer.nextCity(pIter, False)

def addCityWithSpecialBonus(iGameTurn):
    global iCitiesSpecialBonus
    lTurns = [20, 25, 30, 35, 40]
    # Max 3 cities
    if iCitiesSpecialBonus >= iMaxCitiesSpecialBonus:
        return

    lNewCities = []
    for i in range(gc.getMAX_PLAYERS()):
        loopPlayer = gc.getPlayer(i)
        if loopPlayer.isAlive() and not loopPlayer.isHuman() and not loopPlayer.isBarbarian():
            (loopCity, pIter) = loopPlayer.firstCity(False)
            while loopCity:
                if not loopCity.isNone() and loopCity.getOwner() == loopPlayer.getID(): #only valid cities
                    iTurn = CvUtil.getScriptData(loopCity, ["tst"], -1)
                    if iTurn == -1:
                        lNewCities.append(loopCity)
                (loopCity, pIter) = loopPlayer.nextCity(pIter, False)

    iTry = 0
    lNewBonus = []
    while lNewCities and iTry < 3:
        # Stadt auswaehlen
        pCity = lNewCities[CvUtil.myRandom(len(lNewCities), "city addCityWithSpecialBonus")]
        # Dauer auswaehlen
        iTurns = lTurns[CvUtil.myRandom(len(lTurns), "turns addCityWithSpecialBonus")]
        # Bonusgut herausfinden
        for iBonus in L.LBonusLuxury + L.LBonusRarity:
            if not pCity.hasBonus(iBonus):
                lNewBonus.append(iBonus)
        # Bonus setzen wenn die Stadt nicht eh schon alles hat.
        if lNewBonus:
            # Globale Variable setzen
            iCitiesSpecialBonus += 1
            CvUtil.addScriptData(pCity, "tst", iGameTurn+iTurns)
            eBonus = lNewBonus[CvUtil.myRandom(len(lNewBonus), "bonus addCityWithSpecialBonus")]
            CvUtil.addScriptData(pCity, "tsb", eBonus)
            iCityOwner = pCity.getOwner()
            pPlayer = gc.getPlayer(iCityOwner)
            pTeam = gc.getTeam(pPlayer.getTeam())
            iActivePlayer = gc.getGame().getActivePlayer()
            if pTeam.isHasMet(gc.getPlayer(iActivePlayer).getTeam()):
                CyInterface().addMessage(iActivePlayer, True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_SPECIAL_2", (pCity.getName(), gc.getBonusInfo(eBonus).getDescription())), None, 2, None, ColorTypes(11), 0, 0, False, False)
            break
        else:
            iTry += 1
            lNewCities.remove(pCity)

# In doSellBonus
def _doCheckCitySpecialBonus(pUnit, pCity, eBonus):
    global iCitiesSpecialBonus
    eCityBonus = CvUtil.getScriptData(pCity, ["tsb"], -1)
    if eCityBonus != -1 and eCityBonus == eBonus:
        iCitiesSpecialBonus -= 1
        CvUtil.removeScriptData(pCity, "tsb")
        CvUtil.removeScriptData(pCity, "tst")
        iPlayer = pUnit.getOwner()
        pPlayer = gc.getPlayer(iPlayer)
        if iPlayer != gc.getGame().getActivePlayer():
            CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_SPECIAL_3", (pPlayer.getName(),)), None, 2, None, ColorTypes(13), 0, 0, False, False)
        else:
            CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_SPECIAL_4", ("",)), "AS2D_WELOVEKING", 2, None, ColorTypes(13), 0, 0, False, False)
        # Belohnungen
        lGift = []
        # Military unit as gift:
        if CvUtil.myRandom(5, "Military unit as gift") == 1:
            eCiv = gc.getCivilizationInfo(gc.getPlayer(pCity.getOwner()).getCivilizationType())
            eOrigCiv = gc.getCivilizationInfo(gc.getPlayer(pCity.getOriginalOwner()).getCivilizationType())
            lUnits = [
                eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_WAR_ELEPHANT")),
                eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_CAMEL_ARCHER")),
                eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_CAMEL_CATAPHRACT")),
                eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_AUXILIAR_HORSE")),
                eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_SPECIAL4")),                
                eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_AUXILIAR")),
            ]
            # Mounted
            if pCity.isHasBuilding(gc.getInfoTypeForString("BUILDING_STABLE")):
                lUnits.append(gc.getInfoTypeForString("UNIT_HEAVY_HORSEMAN"))
                # Sonderweg mit eOrigCiv
                if pCity.canTrain(eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_CHARIOT")), 0, 0):
                    lGift.append(eOrigCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_CHARIOT")))
                if pCity.canTrain(eCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_HORSE_ARCHER")), 0, 0):
                    lGift.append(eOrigCiv.getCivilizationUnits(gc.getInfoTypeForString("UNITCLASS_HORSE_ARCHER")))
            for iUnit in lUnits:
                if pCity.canTrain(iUnit, 0, 0):
                    lGift.append(iUnit)
            # Set AI Type
            iNewUnitAIType = UnitAITypes.UNITAI_ATTACK
            # Message : Stadt schenkt Truppen
            if pPlayer.isHuman():
                CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_SPECIAL_5", ("",)), "AS2D_WELOVEKING", 2, None, ColorTypes(13), 0, 0, False, False)
        # Standard gift
        if not lGift:
            lGift.append(gc.getInfoTypeForString("UNIT_GOLDKARREN"))
            # Slave
            if pCity.isHasBuilding(gc.getInfoTypeForString("BUILDING_SKLAVENMARKT")) and not pCity.isHasReligion(gc.getInfoTypeForString("RELIGION_CHRISTIANITY")):
                lGift.append(gc.getInfoTypeForString("UNIT_SLAVE"))
            # Mounted
            if pCity.isHasBuilding(gc.getInfoTypeForString("BUILDING_STABLE")):
                lGift.append(gc.getInfoTypeForString("UNIT_HORSE"))
            # Elefant
            if pCity.isHasBuilding(gc.getInfoTypeForString("BUILDING_ELEPHANT_STABLE")):
                lGift.append(gc.getInfoTypeForString("UNIT_ELEFANT"))
            # Kamel
            if pCity.isHasBuilding(gc.getInfoTypeForString("BUILDING_CAMEL_STABLE")):
                lGift.append(gc.getInfoTypeForString("UNIT_CAMEL"))
            # Set AI Type
            iNewUnitAIType = UnitAITypes.NO_UNITAI
            # Message : Stadt schenkt Kostbarkeiten
            if pPlayer.isHuman():
                CyInterface().addMessage(gc.getGame().getActivePlayer(), True, 10, CyTranslator().getText("TXT_KEY_MESSAGE_TRADE_SPECIAL_6", ("",)), "AS2D_WELOVEKING", 2, None, ColorTypes(13), 0, 0, False, False)
        for _ in range(3):
            # Choose units
            iNewUnit = lGift[CvUtil.myRandom(len(lGift), "Choose gift units")]
            # Create units
            pPlayer.initUnit(iNewUnit, pCity.getX(), pCity.getY(), iNewUnitAIType, DirectionTypes.DIRECTION_SOUTH)
